// mySQL4WD.cpp : Defines the entry point for the DLL application.
//

#include <StdAfx.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include <winsock2.h>

#include <mysql.h>
#include "mySQL4WD.h"

#ifdef MYSQL_EMBEDDED
#include <mysql_embed.h>
#endif

// dfinition des variables
//
MYSQL *mySQLEnv[MYSQL_MAX_CONNECTION];
MYSQL_RES *result[MYSQL_MAX_CONNECTION][MYSQL_MAX_STATEMENT];
MYSQL_ROW row[MYSQL_MAX_CONNECTION][MYSQL_MAX_STATEMENT];
unsigned int num_fields[MYSQL_MAX_CONNECTION][MYSQL_MAX_STATEMENT];
my_ulonglong num_rows[MYSQL_MAX_CONNECTION][MYSQL_MAX_STATEMENT];
my_ulonglong current_row[MYSQL_MAX_CONNECTION][MYSQL_MAX_STATEMENT];
BOOL get_result[MYSQL_MAX_CONNECTION][MYSQL_MAX_STATEMENT];

// dbut du code
//
BOOL APIENTRY DllMain(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
	return TRUE;
}

char *strdelch(char *string, const char *lose)
{
	if (!string || !*string)
		return NULL;
	if (lose) {
		char *s;
		for (s = string; *s; ++s) {
		  if (strchr(lose, *s)) {
			strmove(s, s + 1);
			--s;
		  }
		}
	}
	return string;
}

BOOL GetStoreResult(int connection, int requestNumber)
{
	BOOL retCode;

	retCode = TRUE;

	if (!get_result[connection][requestNumber]) {
		get_result[connection][requestNumber] = TRUE;
		result[connection][requestNumber] = mysql_store_result(mySQLEnv[connection]);
		if (result[connection][requestNumber] != NULL) {
			num_fields[connection][requestNumber] = mysql_num_fields(result[connection][requestNumber]);
			num_rows[connection][requestNumber] = mysql_num_rows(result[connection][requestNumber]);
		} else {
			if (mysql_errno(mySQLEnv[connection]) == (unsigned int) 0) {
				if (mysql_field_count(mySQLEnv[connection]) == (unsigned int) 0) {
					num_rows[connection][requestNumber] = mysql_affected_rows(mySQLEnv[connection]);
				} else {
					retCode = FALSE;
				}
			} else {
				retCode = FALSE;
			}
		}
	}

	return (retCode);
}

BOOL GetUseResult(int connection, int requestNumber)
{
	BOOL retCode;

	retCode = TRUE;

	if (!get_result[connection][requestNumber]) {
		get_result[connection][requestNumber] = TRUE;
		result[connection][requestNumber] = mysql_use_result(mySQLEnv[connection]);
		if (result[connection][requestNumber] != NULL) {
			num_fields[connection][requestNumber] = mysql_num_fields(result[connection][requestNumber]);
		} else {
			retCode = FALSE;
		}
	}

	return (retCode);
}

__declspec(dllexport) unsigned int __cdecl mySQLConnecte(int connection, char *host, char *user, char *passwd, char *db, unsigned int port, char *unix_socket, unsigned int client_flag)
{
	unsigned int retCode;
	BOOL mySQLReconnectOption = TRUE;

#ifdef EMBEDDED_LIBRARY
	retCode = (int) mysql_library_init(0, NULL, NULL);
	if (retCode == 1) {
		return (FALSE);
	}
#endif

	retCode = (unsigned int) TRUE;

	mySQLEnv[connection] = mysql_init((MYSQL*) 0);
	if (mySQLEnv[connection] == NULL) {
		retCode = (unsigned int) FALSE;
	} else {
#ifdef EMBEDDED_LIBRARY
		if (!mysql_real_connect(mySQLEnv[connection], NULL, NULL, NULL, db, 0, NULL, 0)) {
#else
		if (!mysql_real_connect(mySQLEnv[connection], host, user, passwd, db, port, unix_socket, client_flag)) {
#endif
			retCode = mysql_errno(mySQLEnv[connection]);
		}
	}

	// depuis 5.0.3, flag MYSQL_OPT_RECONNECT  FALSE
	if (retCode == (unsigned int) TRUE) {
		mysql_options(mySQLEnv[connection], MYSQL_OPT_RECONNECT, (const char *) &mySQLReconnectOption);
	}

	return (retCode);
}

__declspec(dllexport) void __cdecl mySQLDeconnecte(int connection)
{
	int i;

	for (i = 0; i < MYSQL_MAX_STATEMENT; i++) {
		mySQLFerme(connection, i);
	}
	mysql_close(mySQLEnv[connection]);
	
#ifdef EMBEDDED_LIBRARY
	mysql_library_end();
#endif
}

__declspec(dllexport) unsigned int __cdecl mySQLExec(int connection, char *query, unsigned int length, int requestNumber)
{
	unsigned int retCode;

	retCode = (unsigned int) TRUE;

	get_result[connection][requestNumber] = FALSE;

	if (mysql_real_query(mySQLEnv[connection], query, length)) {
		retCode = mysql_errno(mySQLEnv[connection]);
	}

	return (retCode);
}

__declspec(dllexport) void __cdecl mySQLFerme(int connection, int requestNumber)
{
	GetStoreResult(connection, requestNumber);

	get_result[connection][requestNumber] = FALSE;
	num_rows[connection][requestNumber] = (my_ulonglong) 0;
	current_row[connection][requestNumber] = (my_ulonglong) 0;
	num_fields[connection][requestNumber] = (unsigned int) 0;
	if (result[connection][requestNumber] != NULL) {
		mysql_free_result(result[connection][requestNumber]);
	}
}

__declspec(dllexport) unsigned int __cdecl mySQLPremier(int connection, int requestNumber)
{
	unsigned int retCode;

	retCode = (unsigned int) TRUE;

	if (!GetStoreResult(connection, requestNumber)) {
		retCode = mysql_errno(mySQLEnv[connection]);
	} else {
		current_row[connection][requestNumber] = (my_ulonglong) 0;
		mysql_data_seek(result[connection][requestNumber], current_row[connection][requestNumber]);
		row[connection][requestNumber] = mysql_fetch_row(result[connection][requestNumber]);
		if (row[connection][requestNumber] == NULL) {
			retCode = (unsigned int) FALSE;
		}
	}

	return (retCode);
}

__declspec(dllexport) unsigned int __cdecl mySQLDernier(int connection, int requestNumber)
{
	unsigned int retCode;

	retCode = (unsigned int) TRUE;

	if (!GetStoreResult(connection, requestNumber)) {
		retCode = mysql_errno(mySQLEnv[connection]);
	} else {
		current_row[connection][requestNumber] = num_rows[connection][requestNumber] - 1;
		mysql_data_seek(result[connection][requestNumber], current_row[connection][requestNumber]);
		row[connection][requestNumber] = mysql_fetch_row(result[connection][requestNumber]);
		if (row[connection][requestNumber] == NULL) {
			retCode = (unsigned int) FALSE;
		}
	}

	return (retCode);
}

__declspec(dllexport) unsigned int __cdecl mySQLFetch(int connection, int requestNumber)
{
	unsigned int retCode;

	retCode = (unsigned int) TRUE;

	if (!GetUseResult(connection, requestNumber)) {
		retCode = mysql_errno(mySQLEnv[connection]);
	} else {
		row[connection][requestNumber] = mysql_fetch_row(result[connection][requestNumber]);
		if (row[connection][requestNumber] == NULL) {
			retCode = (unsigned int) FALSE;
		}
	}

	return (retCode);
}

__declspec(dllexport) BOOL __cdecl mySQLSuivant(int connection, int requestNumber)
{
	BOOL retCode;

	retCode = TRUE;

	current_row[connection][requestNumber]++;
	mysql_data_seek(result[connection][requestNumber], current_row[connection][requestNumber]);
	row[connection][requestNumber] = mysql_fetch_row(result[connection][requestNumber]);
	if (current_row[connection][requestNumber] == num_rows[connection][requestNumber]) {
		current_row[connection][requestNumber] = num_rows[connection][requestNumber] - 1;
	}

	if (row[connection][requestNumber] == NULL) {
		retCode = FALSE;
	}

	return (retCode);
}

__declspec(dllexport) BOOL __cdecl mySQLPrecedent(int connection, int requestNumber)
{
	BOOL retCode;

	retCode = TRUE;

	current_row[connection][requestNumber]--;
	mysql_data_seek(result[connection][requestNumber], current_row[connection][requestNumber]);
	row[connection][requestNumber] = mysql_fetch_row(result[connection][requestNumber]);
	if (current_row[connection][requestNumber] == (my_ulonglong) -1) {
		current_row[connection][requestNumber] = (my_ulonglong) 0;
	}

	if (row[connection][requestNumber] == NULL) {
		retCode = FALSE;
	}

	return (retCode);
}

__declspec(dllexport) unsigned int __cdecl mySQLNextResult(int connection)
{
	return (mysql_next_result(mySQLEnv[connection]));
}

__declspec(dllexport) void __cdecl mySQLLitCol(int connection, int requestNumber, unsigned int numField, char *fieldName)
{
	MYSQL_FIELD *fields;
	unsigned long *lengths;

	lengths = mysql_fetch_lengths(result[connection][requestNumber]);
	fields = mysql_fetch_fields(result[connection][requestNumber]);

	sprintf(fieldName, "%.*s", (int) lengths[numField], row[connection][requestNumber][numField] ? row[connection][requestNumber][numField] : "NULL");
	if ((fields[numField].type == FIELD_TYPE_DATE || fields[numField].type == FIELD_TYPE_NEWDATE) && row[connection][requestNumber][numField]) {
		strdelch(fieldName, "-");
	}
}

// fonctionnalits spcifiques
//
__declspec(dllexport) void __cdecl mySQLLitColParNom(int connection, int requestNumber, char *mySQLFieldName, char *fieldName)
{
	unsigned int index;
	MYSQL_FIELD *fields;
	unsigned long *lengths;
	char *upperFieldName, *upperSQLFieldName;
	
	lengths = mysql_fetch_lengths(result[connection][requestNumber]);
	fields = mysql_fetch_fields(result[connection][requestNumber]);

	for (index = 0; index <= num_fields[connection][requestNumber]; index++) {
		upperFieldName = strupr(mySQLFieldName);
		upperSQLFieldName = strupr(fields[index].name);
		if (!strcmp(upperSQLFieldName, upperFieldName)) {
			sprintf(fieldName, "%.*s", (int) lengths[index], row[connection][requestNumber][index] ? row[connection][requestNumber][index] : "NULL");
			if (fields[index].type == FIELD_TYPE_DATE || fields[index].type == FIELD_TYPE_NEWDATE && row[connection][requestNumber][index]) {
				strdelch(fieldName, "-");
			}
			break;
		}
	}
}

__declspec(dllexport) void __cdecl mySQLLitLigne(int connection, int requestNumber, char *buffer)
{
	int index = 0;
	MYSQL_FIELD *fields;
	unsigned int numField;
	unsigned long *lengths;

	lengths = mysql_fetch_lengths(result[connection][requestNumber]);
	fields = mysql_fetch_fields(result[connection][requestNumber]);

	for (numField = 0; numField < mysql_num_fields(result[connection][requestNumber]); numField++) {
		char *fieldContent = (char *) malloc(lengths[numField] + 1);
		if (fieldContent != NULL) {
			sprintf(fieldContent, "%.*s", (int) lengths[numField], row[connection][requestNumber][numField] ? row[connection][requestNumber][numField] : "NULL");
			if ((fields[numField].type == FIELD_TYPE_DATE || fields[numField].type == FIELD_TYPE_NEWDATE) && row[connection][requestNumber][numField]) {
				strdelch(fieldContent, "-");
			}
			index += sprintf(buffer + index, "%s\t", fieldContent);
			free(fieldContent);
		}
	}
}

__declspec(dllexport) void __cdecl mySQLLitMemo(int connection, int requestNumber, unsigned int numField, char *fileName)
{
	FILE *stream;
	MYSQL_FIELD *fields;
	unsigned long *lengths;

	lengths = mysql_fetch_lengths(result[connection][requestNumber]);
	fields = mysql_fetch_fields(result[connection][requestNumber]);

	if ((stream = fopen(fileName, "w+")) != NULL) {
		if (row[connection][requestNumber][numField]) {
			fwrite(row[connection][requestNumber][numField], lengths[numField], 1, stream);
		} else {
			char tmpBuffer[] = "NULL";
			fwrite(tmpBuffer, strlen(tmpBuffer), 1, stream);
		}
		fclose(stream);
	}
}

__declspec(dllexport) unsigned int __cdecl mySQLGetNumFields(int connection, int requestNumber)
{
	unsigned int retCode;

	if (!GetStoreResult(connection, requestNumber)) {
		retCode = (unsigned int) 0;
	} else {
		retCode = (unsigned int) num_fields[connection][requestNumber];
	}

	return (retCode);
}

__declspec(dllexport) void __cdecl mySQLGetFieldName(int connection, int requestNumber, unsigned int numField, char *buffer)
{
	MYSQL_FIELD *fields;

	fields = mysql_fetch_fields(result[connection][requestNumber]);
	sprintf(buffer, "%s", fields[numField].name);
}

__declspec(dllexport) unsigned long __cdecl mySQLGetNumRows(int connection, int requestNumber)
{
	unsigned long retCode;

	if (!GetStoreResult(connection, requestNumber)) {
		retCode = (unsigned long) 0;
	} else {
		retCode = (unsigned long) mysql_num_rows(result[connection][requestNumber]);
	}

	return (retCode);
}

__declspec(dllexport) void __cdecl mySQLGetErrorMessage(int connection, char *errorMessage)
{
	sprintf(errorMessage, "%s...", mysql_error(mySQLEnv[connection]));
}

__declspec(dllexport) int __cdecl mySQLGetMaxRequestNumber(void)
{
	return ((int) (MYSQL_MAX_STATEMENT - 1));
}

__declspec(dllexport) int __cdecl mySQLPing(int connection)
{
	return (mysql_ping(mySQLEnv[connection]));
}

__declspec(dllexport) int __cdecl mySQLOptions(int connection, char *defaultGroup)
{
	return (mysql_options(mySQLEnv[connection], MYSQL_READ_DEFAULT_GROUP, defaultGroup));
}

__declspec(dllexport) void __cdecl mySQLInfo(int connection, char *infoMessage)
{
	if (mysql_info(mySQLEnv[connection]) == NULL) {
		strcpy(infoMessage, " ");
	} else {
		sprintf(infoMessage, "%s", mysql_info(mySQLEnv[connection]));
	}
}

__declspec(dllexport) void __cdecl mySQLGetClientInfo(char *infoMessage)
{
	sprintf(infoMessage, "%s", mysql_get_client_info());
}

__declspec(dllexport) void __cdecl mySQLGetHostInfo(int connection, char *infoMessage)
{
	sprintf(infoMessage, "%s", mysql_get_host_info(mySQLEnv[connection]));
}

__declspec(dllexport) void __cdecl mySQLGetServerInfo(int connection, char *infoMessage)
{
	sprintf(infoMessage, "%s", mysql_get_server_info(mySQLEnv[connection]));
}

__declspec(dllexport) int __cdecl mySQLSetServerOption(int connection, int option)
{
	int retCode;

	if (option == 1) {
		retCode = mysql_set_server_option(mySQLEnv[connection], MYSQL_OPTION_MULTI_STATEMENTS_ON);
	} else {
		retCode = mysql_set_server_option(mySQLEnv[connection], MYSQL_OPTION_MULTI_STATEMENTS_OFF);
	}

	return (retCode);
}

__declspec(dllexport) BOOL __cdecl mySQLThreadInit(void)
{
#ifdef EMBEDDED_LIBRARY
	return (my_thread_init());
#else
	return (mysql_thread_init());
#endif
}

__declspec(dllexport) void __cdecl mySQLThreadEnd(void)
{
#ifdef EMBEDDED_LIBRARY
	my_thread_end();
#else
	mysql_thread_end();
#endif
}

__declspec(dllexport) BOOL __cdecl mySQLRequestInUse(int connection, int requestNumber)
{
	return (get_result[connection][requestNumber]);
}

__declspec(dllexport) BOOL __cdecl mySQLTestCompatibilite(char *versionNumber)
{
	BOOL retCode;

	retCode = FALSE;
	if (strcmp(versionNumber, "2.0.0.1") == 0) {
		retCode = TRUE;
	}

	return (retCode);
}
